#include<bits/stdc++.h>
using namespace std;
int n,o,a,b,ab,p[1000005],xa,xb,xo,xab,ostatak,oo,oa,ob,oab;
bool mogucnost;
string s[1000005],res;
int main(){
  mogucnost=true;
  cin>>n;
  cin>>o>>a>>b>>ab;
  for(int i=1;i<=n;i++){
    cin>>s[i]>>p[i];
    if(s[i]=='O'){
      xo+=p[i];
    }
    else if(s[i]=='A'){
      xa+=p[i];
    }
    else if(s[i]=='B'){
      xb+=p[i];
    }
    else if(s[i]=='AB'){
      xab+=p[i];
    }
  }
  if(o>xo){
    mogucnost=false;
  }
  if(xo>=o){
    oo=o-xo;
    if(xa>=a){
      oa
    }
    if(xa<a){
      xa=xa+oo;
        if(xa>=a){
          oo=oo-(xa-a);
          oa=0;
        }
          else{
            mogucnost=false;
          }
    }
    if(xb<b){
      xb=xb+oo;
      if(xb>=b){
        ob=b-xb;
      }
        else{
          mogucnost=false;
        }
    }
  }